diff --git a/src/core/ipv6/dhcp6.c b/src/core/ipv6/dhcp6.c
index e6a7e64d..fbf7621b 100644
--- a/src/core/ipv6/dhcp6.c
+++ b/src/core/ipv6/dhcp6.c
@@ -419,280 +583,767 @@ dhcp6_option_short(u16_t options_out_len, u8_t *options, u16_t value)
   return options_out_len;
 }
 
+#if LWIP_IPV6_DHCP6_STATEFUL
 static u16_t
-dhcp6_option_optionrequest(u16_t options_out_len, u8_t *options, const u16_t *req_options,
-                           u16_t num_req_options, u16_t max_len)
+dhcp6_option_unsigned(u16_t options_out_len, u8_t *options, u32_t value)
 {
-  size_t i;
-  u16_t ret;
+  options[options_out_len++] = (u8_t)((value & 0xff000000U) >> 24);
+  options[options_out_len++] = (u8_t)((value & 0x00ff0000U) >> 16);
+  options[options_out_len++] = (u8_t)((value & 0x0000ff00U) >>  8);
+  options[options_out_len++] = (u8_t) (value & 0x000000ffU);
+  return options_out_len;
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
 
-  LWIP_ASSERT("dhcp6_option_optionrequest: options_out_len + sizeof(struct dhcp6_msg) + addlen <= max_len",
-    sizeof(struct dhcp6_msg) + options_out_len + 4U + (2U * num_req_options) <= max_len);
-  LWIP_UNUSED_ARG(max_len);
+static u16_t
+dhcp6_option_optionrequest_size(void)
+{
+  const u16_t header_size = 4U;
+  const u16_t option_size = 2U;
 
-  ret = dhcp6_option_short(options_out_len, options, DHCP6_OPTION_ORO);
-  ret = dhcp6_option_short(ret, options, 2 * num_req_options);
-  for (i = 0; i < num_req_options; i++) {
-    ret = dhcp6_option_short(ret, options, req_options[i]);
+  u8_t num_requested_options = 0;
+  while (requested_options[num_requested_options] != 0) {
+    num_requested_options++;
   }
-  return ret;
-}
 
-/* All options are added, shrink the pbuf to the required size */
-static void
-dhcp6_msg_finalize(u16_t options_out_len, struct pbuf *p_out)
-{
-  /* shrink the pbuf to the actual content length */
-  pbuf_realloc(p_out, (u16_t)(sizeof(struct dhcp6_msg) + options_out_len));
+  return header_size + (option_size * num_requested_options);
 }
 
-
-#if LWIP_IPV6_DHCP6_STATELESS
-static void
-dhcp6_information_request(struct netif *netif, struct dhcp6 *dhcp6)
+static u16_t
+dhcp6_option_optionrequest(u16_t options_out_len, u8_t *options, u16_t max_len)
 {
-  const u16_t requested_options[] = {
-#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
-    DHCP6_OPTION_DNS_SERVERS,
-    DHCP6_OPTION_DOMAIN_LIST
-#endif
-#if LWIP_DHCP6_GET_NTP_SRV
-    , DHCP6_OPTION_SNTP_SERVERS
-#endif
-  };
+  size_t i;
+  u16_t ret;
+  const u16_t header_size = 4U;
 
-  u16_t msecs;
-  struct pbuf *p_out;
-  u16_t options_out_len;
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_information_request()\n"));
-  /* create and initialize the DHCP message header */
-  p_out = dhcp6_create_msg(netif, dhcp6, DHCP6_INFOREQUEST, 4 + sizeof(requested_options), &options_out_len);
-  if (p_out != NULL) {
-    err_t err;
-    struct dhcp6_msg *msg_out = (struct dhcp6_msg *)p_out->payload;
-    u8_t *options = (u8_t *)(msg_out + 1);
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_information_request: making request\n"));
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt option request: "));
 
-    options_out_len = dhcp6_option_optionrequest(options_out_len, options, requested_options,
-      LWIP_ARRAYSIZE(requested_options), p_out->len);
-    LWIP_HOOK_DHCP6_APPEND_OPTIONS(netif, dhcp6, DHCP6_STATE_REQUESTING_CONFIG, msg_out,
-      DHCP6_INFOREQUEST, options_out_len, p_out->len);
-    dhcp6_msg_finalize(options_out_len, p_out);
+  LWIP_ASSERT("dhcp6_option_optionrequest: packet too small",
+    options_out_len + dhcp6_option_optionrequest_size() <= max_len);
+  LWIP_UNUSED_ARG(max_len);
 
-    err = udp_sendto_if(dhcp6_pcb, p_out, &dhcp6_All_DHCP6_Relay_Agents_and_Servers, DHCP6_SERVER_PORT, netif);
-    pbuf_free(p_out);
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_information_request: INFOREQUESTING -> %d\n", (int)err));
-    LWIP_UNUSED_ARG(err);
-  } else {
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_SERIOUS, ("dhcp6_information_request: could not allocate DHCP6 request\n"));
-  }
-  dhcp6_set_state(dhcp6, DHCP6_STATE_REQUESTING_CONFIG, "dhcp6_information_request");
-  if (dhcp6->tries < 255) {
-    dhcp6->tries++;
+  ret = dhcp6_option_short(options_out_len, options, DHCP6_OPTION_ORO);
+  ret = dhcp6_option_short(ret, options, dhcp6_option_optionrequest_size() - header_size);
+  for (i = 0; requested_options[i] != 0; i++) {
+    ret = dhcp6_option_short(ret, options, requested_options[i]);
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%"U16_F", ", requested_options[i]));
   }
-  msecs = (u16_t)((dhcp6->tries < 6 ? 1 << dhcp6->tries : 60) * 1000);
-  dhcp6->request_timeout = (u16_t)((msecs + DHCP6_TIMER_MSECS - 1) / DHCP6_TIMER_MSECS);
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_information_request(): set request timeout %"U16_F" msecs\n", msecs));
-}
 
-static err_t
-dhcp6_request_config(struct netif *netif, struct dhcp6 *dhcp6)
-{
-  /* stateless mode enabled and no request running? */
-  if (dhcp6->state == DHCP6_STATE_STATELESS_IDLE) {
-    /* send Information-request and wait for answer; setup receive timeout */
-    dhcp6_information_request(netif, dhcp6);
-  }
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("\n"));
 
-  return ERR_OK;
+  return ret;
 }
 
-static void
-dhcp6_abort_config_request(struct dhcp6 *dhcp6)
+#if LWIP_IPV6_DHCP6_STATEFUL
+static u16_t
+dhcp6_option_ia_na_size(struct dhcp6 *dhcp6, u8_t include_addr)
 {
-  if (dhcp6->state == DHCP6_STATE_REQUESTING_CONFIG) {
-    /* abort running request */
-    dhcp6_set_state(dhcp6, DHCP6_STATE_STATELESS_IDLE, "dhcp6_abort_config_request");
+  if (include_addr && (!is_addr_advertised(dhcp6))) {
+    /* We don't have address to add */
+    return 0;
+
+  } else {
+    const u16_t option_iaaddr_len = 28;
+    const u16_t ia_na_len = 16 + ((include_addr) ? option_iaaddr_len : 0);
+
+    return ia_na_len;
   }
 }
 
-/* Handle a REPLY to INFOREQUEST
- * This parses DNS and NTP server addresses from the reply.
+/**
+ * Add Identity association for Non temporary address request option into msg
  */
-static void
-dhcp6_handle_config_reply(struct netif *netif, struct pbuf *p_msg_in)
+static u16_t
+dhcp6_option_ia_na(struct netif *netif, struct dhcp6 *dhcp6, u8_t include_addr,  u16_t options_out_len, u8_t *options, u16_t max_len)
 {
-  struct dhcp6 *dhcp6 = netif_dhcp6_data(netif);
+  if (include_addr && (!is_addr_advertised(dhcp6))) {
+    /* We don't have address to add */
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt IA_NA: Not adding IA_NA because srv didn't offered any\n"));
+    return options_out_len;
 
-  LWIP_UNUSED_ARG(dhcp6);
-  LWIP_UNUSED_ARG(p_msg_in);
+  } else {
+    u16_t ret;
+    const u16_t ia_na_len = dhcp6_option_ia_na_size(dhcp6, include_addr);
 
-#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
-  if (dhcp6_option_given(dhcp6, DHCP6_OPTION_IDX_DNS_SERVER)) {
-    ip_addr_t dns_addr;
-    ip6_addr_t *dns_addr6;
-    u16_t op_start = dhcp6_get_option_start(dhcp6, DHCP6_OPTION_IDX_DNS_SERVER);
-    u16_t op_len = dhcp6_get_option_length(dhcp6, DHCP6_OPTION_IDX_DNS_SERVER);
-    u16_t idx;
-    u8_t n;
-
-    ip_addr_set_zero_ip6(&dns_addr);
-    dns_addr6 = ip_2_ip6(&dns_addr);
-    for (n = 0, idx = op_start; (idx < op_start + op_len) && (n < LWIP_DHCP6_PROVIDE_DNS_SERVERS);
-         n++, idx += sizeof(struct ip6_addr_packed)) {
-      u16_t copied = pbuf_copy_partial(p_msg_in, dns_addr6, sizeof(struct ip6_addr_packed), idx);
-      if (copied != sizeof(struct ip6_addr_packed)) {
-        /* pbuf length mismatch */
-        return;
-      }
-      ip6_addr_assign_zone(dns_addr6, IP6_UNKNOWN, netif);
-      /* @todo: do we need a different offset than DHCP(v4)? */
-      dns_setserver(n, &dns_addr);
-    }
-  }
-  /* @ todo: parse and set Domain Search List */
-#endif /* LWIP_DHCP6_PROVIDE_DNS_SERVERS */
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt IA_NA\n"));
 
-#if LWIP_DHCP6_GET_NTP_SRV
-  if (dhcp6_option_given(dhcp6, DHCP6_OPTION_IDX_NTP_SERVER)) {
-    ip_addr_t ntp_server_addrs[LWIP_DHCP6_MAX_NTP_SERVERS];
-    u16_t op_start = dhcp6_get_option_start(dhcp6, DHCP6_OPTION_IDX_NTP_SERVER);
-    u16_t op_len = dhcp6_get_option_length(dhcp6, DHCP6_OPTION_IDX_NTP_SERVER);
-    u16_t idx;
-    u8_t n;
-
-    for (n = 0, idx = op_start; (idx < op_start + op_len) && (n < LWIP_DHCP6_MAX_NTP_SERVERS);
-         n++, idx += sizeof(struct ip6_addr_packed)) {
-      u16_t copied;
-      ip6_addr_t *ntp_addr6 = ip_2_ip6(&ntp_server_addrs[n]);
-      ip_addr_set_zero_ip6(&ntp_server_addrs[n]);
-      copied = pbuf_copy_partial(p_msg_in, ntp_addr6, sizeof(struct ip6_addr_packed), idx);
-      if (copied != sizeof(struct ip6_addr_packed)) {
-        /* pbuf length mismatch */
-        return;
-      }
-      ip6_addr_assign_zone(ntp_addr6, IP6_UNKNOWN, netif);
+    LWIP_ASSERT("dhcp6_option_ia_na: packet too small", options_out_len + ia_na_len <= max_len);
+    LWIP_UNUSED_ARG(max_len);
+
+    ret = dhcp6_option_short(options_out_len, options, DHCP6_OPTION_IA_NA);
+    ret = dhcp6_option_short(ret, options, ia_na_len - 4); /* exclude option header */
+
+    memcpy(&options[ret], &netif->hwaddr[1], 4); /* IAID */
+    ret += 4;
+
+    /* 0 means no client preference for those values */
+    ret = dhcp6_option_unsigned(ret, options, dhcp6->addr_t1);
+    ret = dhcp6_option_unsigned(ret, options, dhcp6->addr_t2);
+
+    if (include_addr) {
+      const u16_t option_iaaddr_len = 24;
+
+      ret = dhcp6_option_short(ret, options, DHCP6_OPTION_IAADDR);
+      ret = dhcp6_option_short(ret, options, option_iaaddr_len);
+
+      memcpy(&options[ret], dhcp6->addr.addr, sizeof(dhcp6->addr.addr));
+      ret += sizeof(dhcp6->addr.addr);
+
+      ret = dhcp6_option_unsigned(ret, options, dhcp6->addr_pref); /* preferred time */
+      ret = dhcp6_option_unsigned(ret, options, dhcp6->addr_valid); /* valid time */
     }
-    dhcp6_set_ntp_servers(n, ntp_server_addrs);
+
+    return ret;
   }
-#endif /* LWIP_DHCP6_GET_NTP_SRV */
 }
-#endif /* LWIP_IPV6_DHCP6_STATELESS */
+#endif  /* LWIP_IPV6_DHCP6_STATEFUL */
 
-/** This function is called from nd6 module when an RA message is received
- * It triggers DHCPv6 requests (if enabled).
- */
-void
-dhcp6_nd6_ra_trigger(struct netif *netif, u8_t managed_addr_config, u8_t other_config)
+#if LWIP_IPV6_DHCP6_PD
+static u16_t
+dhcp6_option_ia_pd_size(const struct dhcp6 *dhcp6, u8_t include_prefix)
 {
-  struct dhcp6 *dhcp6;
-
-  LWIP_ASSERT("netif != NULL", netif != NULL);
-  dhcp6 = netif_dhcp6_data(netif);
-
-  LWIP_UNUSED_ARG(managed_addr_config);
-  LWIP_UNUSED_ARG(other_config);
-  LWIP_UNUSED_ARG(dhcp6);
+  if (include_prefix && (!is_prefix_advertised(dhcp6))) {
+    /* We don't have any prefix to add */
+    return 0;
+  } else {
+    const u16_t ia_prefix_len = 25 + 4;
+    const u16_t ia_pd_len = 16 + ((include_prefix) ? ia_prefix_len : 0);
 
-#if LWIP_IPV6_DHCP6_STATELESS
-  if (dhcp6 != NULL) {
-    if (dhcp6_stateless_enabled(dhcp6)) {
-      if (other_config) {
-        dhcp6_request_config(netif, dhcp6);
-      } else {
-        dhcp6_abort_config_request(dhcp6);
-      }
-    }
+    return ia_pd_len;
   }
-#endif /* LWIP_IPV6_DHCP6_STATELESS */
 }
 
 /**
- * Parse the DHCPv6 message and extract the DHCPv6 options.
- *
- * Extract the DHCPv6 options (offset + length) so that we can later easily
- * check for them or extract the contents.
+ * Add Identity association for prefix delegation option into msg
  */
-static err_t
-dhcp6_parse_reply(struct pbuf *p, struct dhcp6 *dhcp6)
+static u16_t
+dhcp6_option_ia_pd(struct netif *netif, struct dhcp6 *dhcp6, u8_t include_prefix, u16_t options_out_len, u8_t *options, u16_t max_len)
 {
-  u16_t offset;
-  u16_t offset_max;
-  u16_t options_idx;
-  struct dhcp6_msg *msg_in;
+  if (include_prefix && (!is_prefix_advertised(dhcp6))) {
+    /* We don't have any prefix to add */
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt IA_PD: Not adding IA_PD because srv didn't offered any\n"));
+    return options_out_len;
 
-  LWIP_UNUSED_ARG(dhcp6);
+  } else {
+    u16_t ret;
 
-  /* clear received options */
-  dhcp6_clear_all_options(dhcp6);
-  msg_in = (struct dhcp6_msg *)p->payload;
-
-  /* parse options */
-
-  options_idx = sizeof(struct dhcp6_msg);
-  /* parse options to the end of the received packet */
-  offset_max = p->tot_len;
-
-  offset = options_idx;
-  /* at least 4 byte to read? */
-  while ((offset + 4 <= offset_max)) {
-    u8_t op_len_buf[4];
-    u8_t *op_len;
-    u16_t op;
-    u16_t len;
-    u16_t val_offset = (u16_t)(offset + 4);
-    if (val_offset < offset) {
-      /* overflow */
-      return ERR_BUF;
-    }
-    /* copy option + length, might be split across pbufs */
-    op_len = (u8_t *)pbuf_get_contiguous(p, op_len_buf, 4, 4, offset);
-    if (op_len == NULL) {
-      /* failed to get option and length */
-      return ERR_VAL;
+    const u16_t ia_prefix_len = 25;
+    const u16_t ia_pd_len = dhcp6_option_ia_pd_size(dhcp6, include_prefix);
+
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt option IA_PD\n"));
+
+    LWIP_ASSERT("dhcp6_option_ia_pd: packet too small.",
+                options_out_len + ia_pd_len <= max_len);
+    LWIP_UNUSED_ARG(max_len);
+
+
+    ret = dhcp6_option_short(options_out_len, options, DHCP6_OPTION_IA_PD);
+    ret = dhcp6_option_short(ret, options, ia_pd_len - 4);
+
+    memcpy(&options[ret], &netif->hwaddr[1], 4); /* IAID */
+    ret += 4;
+
+    ret = dhcp6_option_unsigned(ret, options, include_prefix ? dhcp6->ia_pd_t1 : 0); /* T1 */
+    ret = dhcp6_option_unsigned(ret, options, include_prefix ? dhcp6->ia_pd_t2 : 0); /* T2 */
+
+    if (include_prefix) {
+      ret = dhcp6_option_short(ret, options, DHCP6_OPTION_IAPREFIX);
+      ret = dhcp6_option_short(ret, options, ia_prefix_len);
+      ret = dhcp6_option_unsigned(ret, options, dhcp6->prefix.prefix_pref); /* preferred time */
+      ret = dhcp6_option_unsigned(ret, options, dhcp6->prefix.prefix_valid); /* valid time */
+      ret = dhcp6_option_byte(ret, options, dhcp6->prefix.prefix_len);
+
+      memcpy(&options[ret], dhcp6->prefix.prefix.addr, sizeof(dhcp6->prefix.prefix.addr));
+      ret += sizeof(dhcp6->prefix.prefix.addr);
     }
-    op = (op_len[0] << 8) | op_len[1];
-    len = (op_len[2] << 8) | op_len[3];
-    offset = val_offset + len;
-    if (offset < val_offset) {
-      /* overflow */
-      return ERR_BUF;
+
+    return ret;
+  }
+}
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+static u16_t
+dhcp6_option_client_identifier_size(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  const u16_t duid_ll_len = 4 + netif->hwaddr_len;
+  const u16_t clientid_len = 4 + ( (dhcp6->cli_id_usr_duid != NULL) ? dhcp6->cli_id_usr_duid_len : duid_ll_len );
+  return clientid_len;
+}
+
+static u16_t
+dhcp6_option_client_identifier(struct netif *netif, struct dhcp6 *dhcp6, u16_t options_out_len, u8_t *options, u16_t max_len)
+{
+  u16_t ret;
+
+  const u16_t clientid_len = dhcp6_option_client_identifier_size(netif, dhcp6);
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt client identifier: (Using hw addr as DUID)\n"));
+
+  LWIP_ASSERT("dhcp6_option_client_identifier: packet too small",
+                (options_out_len + clientid_len) <= max_len);
+  LWIP_UNUSED_ARG(max_len);
+
+  ret = dhcp6_option_short(options_out_len, options, DHCP6_OPTION_CLIENTID);
+  ret = dhcp6_option_short(ret, options, clientid_len - 4);
+
+  if (dhcp6->cli_id_usr_duid != NULL) {
+    memcpy(&options[ret], dhcp6->cli_id_usr_duid, dhcp6->cli_id_usr_duid_len);
+    ret += dhcp6->cli_id_usr_duid_len;
+  } else {
+  /*
+    0                   1                   2                   3
+    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+   |               3               |    hardware type (16 bits)    |
+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+   .                                                               .
+   .             link-layer address (variable length)              .
+   .                                                               .
+   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+   */
+
+    ret = dhcp6_option_short(ret, options, DHCP6_DUID_LL);
+    ret = dhcp6_option_short(ret, options, LWIP_IANA_HWTYPE_ETHERNET);
+    memcpy(&options[ret], netif->hwaddr, 6);
+    ret += 6;
+  }
+
+  return ret;
+}
+
+
+static u16_t
+dhcp6_option_server_identifier_size(struct dhcp6 *dhcp6)
+{
+  return dhcp6->server_id_len;
+}
+
+static u16_t
+dhcp6_option_server_identifier(struct dhcp6 *dhcp6,const u16_t options_out_len, u8_t *options, u16_t max_len)
+{
+  const u16_t len = dhcp6_option_server_identifier_size(dhcp6);
+
+  LWIP_ASSERT("dhcp6_option_server_identifier: dhcp6->server_id != NULL", dhcp6->server_id != NULL);
+  LWIP_ASSERT("dhcp6_option_server_identifier: packet too small",
+              options_out_len + len <= max_len);
+  LWIP_UNUSED_ARG(max_len);
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt server ID\n"));
+
+  memcpy(&options[options_out_len], dhcp6->server_id, len);
+
+  return options_out_len + len;
+}
+
+
+static u16_t
+dhcp6_option_elapsed_size(void)
+{
+  return 6U;
+}
+
+static u16_t
+dhcp6_option_elapsed(struct dhcp6 *dhcp6, u16_t options_out_len, u8_t *options, u16_t max_len)
+{
+  u16_t ret;
+  const u32_t elapsed_32 = (sys_now() - dhcp6->trans_started_at) / 10;
+  const u16_t elapsed_16 = (elapsed_32 >= 0xffff) ? 0xffff : (u16_t)elapsed_32;
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" Add opt elapsed: %"U16_F"0 ms\n", elapsed_16));
+
+  LWIP_ASSERT("dhcp6_option_elapsed: packet too small",
+              (options_out_len + dhcp6_option_elapsed_size()) <= max_len);
+  LWIP_UNUSED_ARG(max_len);
+
+  ret = dhcp6_option_short(options_out_len, options, DHCP6_OPTION_ELAPSED_TIME);
+  ret = dhcp6_option_short(ret, options, dhcp6_option_elapsed_size() - 4);
+  ret = dhcp6_option_short(ret, options, elapsed_16);
+
+  return ret;
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+/* All options are added, shrink the pbuf to the required size */
+static void
+dhcp6_msg_finalize(struct dhcp6 *dhcp6, u16_t options_out_len, struct pbuf *p_out)
+{
+  /* shrink the pbuf to the actual content length */
+  pbuf_realloc(p_out, (u16_t)(sizeof(struct dhcp6_msg) + options_out_len));
+
+  if (dhcp6->tries < 255) {
+    dhcp6->tries++;
+  }
+
+}
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+/**
+ * Compose and send statefull message
+ * @param dhcp6
+ * @param message_type dhcp6 message type
+ * @param fill_addr_and_prefix  true: If addr/prefix is present in dhcp6 struct ia_na/ia_pd with addr/prefix will be
+ *                                    appended to msg. If not present ia_na/ia_pd will not be added to msg.
+ *                              false: ia_pd/ia_na without prefix/address will be appended to msg.
+ * @param fill_srvid  If true copies server id into
+ */
+static void
+dhcp6_send_stateful_msg(struct netif *netif, struct dhcp6 *dhcp6, u8_t message_type,
+                        u8_t fill_addr_and_prefix, u8_t fill_srvid)
+{
+  struct pbuf *p_out;
+  u16_t options_out_len;
+  u16_t size = dhcp6_option_client_identifier_size(netif, dhcp6) + dhcp6_option_optionrequest_size() +
+               dhcp6_option_elapsed_size();
+
+#if LWIP_IPV6_DHCP6_PD
+    size += dhcp6_option_ia_pd_size(dhcp6, fill_addr_and_prefix);
+#endif
+
+  if (!dhcp6->addr_by_slaac) {
+    size += dhcp6_option_ia_na_size(dhcp6, fill_addr_and_prefix);
+  }
+  if (fill_srvid) {
+    size += dhcp6_option_server_identifier_size(dhcp6);
+  }
+
+  /* create and initialize the DHCP message header */
+  p_out = dhcp6_create_msg(netif, dhcp6, message_type, size, &options_out_len);
+  if (p_out != NULL) {
+    err_t err;
+    struct dhcp6_msg *msg_out = (struct dhcp6_msg *)p_out->payload;
+    u8_t *options = (u8_t *)(msg_out + 1);
+    const u16_t options_max_len = size;
+
+    if (!dhcp6->addr_by_slaac) {
+      options_out_len = dhcp6_option_ia_na(netif, dhcp6, fill_addr_and_prefix,
+                                           options_out_len, options, options_max_len);
     }
 
-    switch (op) {
-      case (DHCP6_OPTION_CLIENTID):
-        dhcp6_got_option(dhcp6, DHCP6_OPTION_IDX_CLI_ID);
-        dhcp6_set_option(dhcp6, DHCP6_OPTION_IDX_CLI_ID, val_offset, len);
+    options_out_len = dhcp6_option_client_identifier(netif, dhcp6, options_out_len, options, options_max_len);
+    if (fill_srvid) {
+      options_out_len = dhcp6_option_server_identifier(dhcp6, options_out_len, options, options_max_len);
+    }
+    options_out_len = dhcp6_option_optionrequest(options_out_len, options, options_max_len);
+    options_out_len = dhcp6_option_elapsed(dhcp6, options_out_len, options, options_max_len);
+#if LWIP_IPV6_DHCP6_PD
+    options_out_len = dhcp6_option_ia_pd(netif, dhcp6, fill_addr_and_prefix, options_out_len, options, options_max_len);
+#endif
+    dhcp6_msg_finalize(dhcp6, options_out_len, p_out);
+
+    err = udp_sendto_if (dhcp6_pcb, p_out, &dhcp6_All_DHCP6_Relay_Agents_and_Servers, DHCP6_SERVER_PORT, netif);
+    pbuf_free(p_out);
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_send_stateful_msg: sent, udp_sendto_if returned %d\n", (int)err));
+    LWIP_UNUSED_ARG(err);
+  } else {
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_SERIOUS, ("dhcp6_send_stateful_msg: could not allocate DHCP6 request\n"));
+  }
+}
+
+static void
+dhcp6_solicitation(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_solicitation: preparing msg\n"));
+  dhcp6_send_stateful_msg(netif, dhcp6, DHCP6_SOLICIT, 0, 0);
+}
+
+static void
+dhcp6_request(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_request: preparing msg\n"));
+  dhcp6_send_stateful_msg(netif, dhcp6, DHCP6_REQUEST, 1, 1);
+}
+
+static void
+dhcp6_renew(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_renew: preparing msg\n"));
+  dhcp6_send_stateful_msg(netif, dhcp6, DHCP6_RENEW, 1, 1);
+}
+
+static void
+dhcp6_rebind(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_rebind: preparing msg\n"));
+  dhcp6_send_stateful_msg(netif, dhcp6, DHCP6_RENEW, 1, 0);
+}
+
+static void
+dhcp6_release(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_release: preparing msg\n"));
+  dhcp6_send_stateful_msg(netif, dhcp6, DHCP6_RELEASE, 1, 1);
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFULL */
+
+#if LWIP_IPV6_DHCP6_STATELESS
+/**
+ * Send information request (stateless)
+ */
+static void
+dhcp6_information_request(struct netif *netif, struct dhcp6 *dhcp6)
+{
+  struct pbuf *p_out;
+  u16_t options_out_len;
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_information_request: preparing msg\n"));
+  /* create and initialize the DHCP message header */
+  p_out = dhcp6_create_msg(netif, dhcp6, DHCP6_INFOREQUEST, dhcp6_option_optionrequest_size(), &options_out_len);
+  if (p_out != NULL) {
+    err_t err;
+    struct dhcp6_msg *msg_out = (struct dhcp6_msg *)p_out->payload;
+    u8_t *options = (u8_t *)(msg_out + 1);
+
+    options_out_len = dhcp6_option_optionrequest(options_out_len, options, p_out->len);
+
+    dhcp6_msg_finalize(dhcp6, options_out_len, p_out);
+
+    err = udp_sendto_if (dhcp6_pcb, p_out, &dhcp6_All_DHCP6_Relay_Agents_and_Servers, DHCP6_SERVER_PORT, netif);
+    pbuf_free(p_out);
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_information_request: sent with return code %d\n", (int)err));
+    LWIP_UNUSED_ARG(err);
+  } else {
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_SERIOUS, ("dhcp6_information_request: could not allocate DHCP6 request\n"));
+  }
+}
+
+#endif /* LWIP_IPV6_DHCP6_STATELESS */
+
+/** This function is called from nd6 module when an RA message is received
+ * It triggers DHCPv6 requests (if enabled).
+ *
+ * @param managed_addr_config Managed Address Config Flag tells the host if it should use stateful DHCPv6
+ * @param other_config        Other Config Flag tells the host that there is other information the router can provide.
+ */
+void
+dhcp6_nd6_ra_trigger(struct netif *netif, u8_t managed_addr_config, u8_t other_config)
+{
+  struct dhcp6 *dhcp6;
+#if !LWIP_IPV6_DHCP6_STATEFUL
+  LWIP_UNUSED_ARG(managed_addr_config);
+#endif
+
+  LWIP_ASSERT("netif != NULL", netif != NULL);
+  dhcp6 = netif_dhcp6_data(netif);
+
+  if (dhcp6 != NULL) {
+
+    switch (dhcp6->state) {
+      case DHCP6_STATE_IDLE:
+#if LWIP_IPV6_DHCP6_STATEFUL
+        dhcp6->addr_by_slaac = !managed_addr_config;
+
+        if (managed_addr_config) {
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_INIT_DELAY, "ra_trigger M flag");
+          break;
+        }
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+        if (other_config) {
+#if LWIP_IPV6_DHCP6_PD
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_INIT_DELAY, "ra_trigger O flag");
+#else
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SL_REQUESTING_CONFIG, "ra_trigger O flag");
+#endif
+          break;
+        }
         break;
-      case (DHCP6_OPTION_SERVERID):
-        dhcp6_got_option(dhcp6, DHCP6_OPTION_IDX_SERVER_ID);
-        dhcp6_set_option(dhcp6, DHCP6_OPTION_IDX_SERVER_ID, val_offset, len);
+      case DHCP6_STATE_OFF:
+      case DHCP6_STATE_SL_REQUESTING_CONFIG:
+#if LWIP_IPV6_DHCP6_STATEFUL
+      case DHCP6_STATE_SF_INIT_DELAY:
+      case DHCP6_STATE_SF_SOLICITING:
+      case DHCP6_STATE_SF_REQUESTING:
+      case DHCP6_STATE_SF_BOUND:
+      case DHCP6_STATE_SF_RENEWING:
+      case DHCP6_STATE_SF_REBINDING:
+      case DHCP6_STATE_SF_RELEASING:
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
         break;
+
+      default:
+        LWIP_ASSERT("Unhandled state at dhcp6_nd6_ra_trigger", 0);
+    } /* switch */
+  }
+
+}
+ /* copies option into bufer and retrns its len or -1 and sets offset param to beginning of option data (after header) */
+static s16_t dhcp6_find_option(const struct pbuf *p, u16_t option_code, u16_t *offset)
+{
+  const u16_t opt_hdr_len = 4;
+
+  while (((*offset) + opt_hdr_len) <= p->tot_len) {
+    const u8_t hdr_len = sizeof(struct dhcp6_option_header);
+    u8_t hdr_buf[sizeof(struct dhcp6_option_header)];
+
+    struct dhcp6_option_header *hdr =
+            (struct dhcp6_option_header *) pbuf_get_contiguous(p, hdr_buf, hdr_len, hdr_len, *offset);
+
+    if (hdr != NULL) {
+      u16_t next_offset;
+      const u16_t found_opt_code = lwip_ntohs(hdr->option_code);
+      const u16_t found_opt_len = lwip_ntohs(hdr->option_len);
+
+      *offset += hdr_len;
+      next_offset = *offset + found_opt_len;
+
+      if (next_offset > p->tot_len) {
+        return -1; /* bad packet */
+      }
+
+      if (found_opt_code == option_code) {
+        return found_opt_len;
+      }
+
+      *offset = next_offset;
+    } else {
+      return -1;
+    }
+  }
+  return -1;
+}
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+/* stores server id in to dhcp6 struct return 1 on success */
+static u8_t
+dhcp6_parse_and_store_serverid(struct pbuf *p, u16_t offset, struct dhcp6 *dhcp6)
+{
+  void *ptr;
+  /* store option including its header.  */
+  const s16_t server_id_len = dhcp6_find_option(p, DHCP6_OPTION_SERVERID, &offset) + 4;
+  offset -= 4;
+
+  if (server_id_len < 0) {
+    return 0;
+  }
+
+  if (dhcp6->server_id != NULL) {
+    mem_free(dhcp6->server_id);
+  }
+  dhcp6->server_id = mem_malloc(server_id_len);
+
+  if (dhcp6->server_id == NULL) {
+    return 0;
+  }
+
+  ptr = pbuf_get_contiguous(p, dhcp6->server_id, server_id_len, server_id_len, offset);
+  if (ptr == NULL) {
+    return 0;
+  } else if (ptr != dhcp6->server_id) {
+    memcpy(dhcp6->server_id, ptr, server_id_len);
+    dhcp6->server_id_len = server_id_len;
+  }
+
+  return 1;
+}
+
+/* returns 0 if received and  */
+static u8_t
+dhcp6_parse_and_check_serverid_different(struct pbuf *p, u16_t offset, struct dhcp6 *dhcp6)
+{
+  u16_t are_different;
+  /* store option including its header.  */
+  const s16_t server_id_len = dhcp6_find_option(p, DHCP6_OPTION_SERVERID, &offset) + 4;
+  offset -= 4;
+
+  if (server_id_len < 0) {
+    return 2;
+  } else if (server_id_len != dhcp6->server_id_len) {
+    return 3;
+  }
+
+  LWIP_ASSERT("DHCP6: Check of server id requested but we haven't stored any", dhcp6->server_id != NULL);
+
+  are_different = pbuf_memcmp(p, offset, dhcp6->server_id, server_id_len);
+
+  return are_different;
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
 #if LWIP_DHCP6_PROVIDE_DNS_SERVERS
-      case (DHCP6_OPTION_DNS_SERVERS):
-        dhcp6_got_option(dhcp6, DHCP6_OPTION_IDX_DNS_SERVER);
-        dhcp6_set_option(dhcp6, DHCP6_OPTION_IDX_DNS_SERVER, val_offset, len);
-        break;
-      case (DHCP6_OPTION_DOMAIN_LIST):
-        dhcp6_got_option(dhcp6, DHCP6_OPTION_IDX_DOMAIN_LIST);
-        dhcp6_set_option(dhcp6, DHCP6_OPTION_IDX_DOMAIN_LIST, val_offset, len);
-        break;
+/* Parses list of dns servers and sets them into lwIP */
+static u8_t
+dhcp6_parse_dns_servers(const struct netif *netif, const struct pbuf *p, u16_t offset)
+{
+  uint8_t i;
+  ip_addr_t addr;
+  s16_t dns_opt_len = dhcp6_find_option(p, DHCP6_OPTION_DNS_SERVERS, &offset);
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" dhcp6_parse_dns_servers:"));
+
+  if (dns_opt_len < 16 ) {
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" got none\n"));
+    return 0;
+  }
+
+  ip_addr_set_zero_ip6(&addr);
+
+  for(i=0; dns_opt_len >= 16 && i < LWIP_DHCP6_MAX_DNS_SERVERS; i++) {
+    uint16_t n = pbuf_copy_partial(p, &addr.u_addr.ip6.addr, 16, offset);
+    if (n == 16) {
+      ip6_addr_assign_zone(&addr.u_addr.ip6, IP6_UNKNOWN, netif);
+      dns_setserver(i, &addr);
+      offset += 16;
+      dns_opt_len -= 16;
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" %s,", ipaddr_ntoa(&addr)));
+    } else {
+      break;
+    }
+  }
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("\n"));
+
+  /* Reset remaining slots */
+  for (; i < LWIP_DHCP6_MAX_DNS_SERVERS; i++) {
+      dns_setserver(i, NULL);
+  }
+
+  return 1;
+}
 #endif /* LWIP_DHCP6_PROVIDE_DNS_SERVERS */
+
 #if LWIP_DHCP6_GET_NTP_SRV
-      case (DHCP6_OPTION_SNTP_SERVERS):
-        dhcp6_got_option(dhcp6, DHCP6_OPTION_IDX_NTP_SERVER);
-        dhcp6_set_option(dhcp6, DHCP6_OPTION_IDX_NTP_SERVER, val_offset, len);
-        break;
-#endif /* LWIP_DHCP6_GET_NTP_SRV*/
-      default:
-        LWIP_DEBUGF(DHCP6_DEBUG, ("skipping option %"U16_F" in options\n", op));
-        LWIP_HOOK_DHCP6_PARSE_OPTION(ip_current_netif(), dhcp6, dhcp6->state, msg_in,
-          msg_in->msgtype, op, len, q, val_offset);
-        break;
+/* stores server id in to dhcp6 struct return 1 on success */
+static u8_t
+dhcp6_parse_sntp_servers(const struct netif * netif, const struct pbuf *p, u16_t offset)
+{
+  uint8_t num = 0;
+  ip_addr_t addrs[LWIP_DHCP6_MAX_SNTP_SERVERS];
+  s16_t sntp_opt_len = dhcp6_find_option(p, DHCP6_OPTION_SNTP_SERVERS, &offset);
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" dhcp6_parse_sntp_servers:"));
+  if (sntp_opt_len < 16) {
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" got none\n"));
+  }
+
+  for (; sntp_opt_len >= 16 && num < LWIP_DHCP6_MAX_SNTP_SERVERS; num++) {
+    ip_addr_set_zero_ip6(&addrs[num]);
+    if (pbuf_copy_partial(p, &addrs[num].u_addr.ip6.addr, 16, offset) == 16) {
+      ip6_addr_assign_zone(&addrs[num].u_addr.ip6, IP6_UNKNOWN, netif);
+      offset += 16;
+      sntp_opt_len -= 16;
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" %s,", ipaddr_ntoa(&addrs[num])));
+    } else {
+      break;
+    }
+  }
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("\n"));
+
+  dhcp6_set_ntp_servers(num, addrs);
+
+  return (num > 0) ? 1 : 0;
+}
+#endif /* LWIP_DHCP6_GET_NTP_SRV */
+
+#ifdef LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM
+static void
+dhcp6_parse_oro_opts_custom(const struct netif * netif, const struct dhcp6 * dhcp6, const struct pbuf *p, u16_t offset)
+{
+  u8_t i = 0;
+  u16_t opt_offset = offset;
+
+  /* Ignore opts already handled by dhcp client */
+#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
+  i++;
+#endif
+#if LWIP_DHCP6_GET_NTP_SRV
+  i++;
+#endif
+
+  for (; requested_options[i] != 0; i++) {
+    s16_t opt_len = dhcp6_find_option(p, requested_options[i], &opt_offset);
+    if (opt_len >= 0) {
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" dhcp6_parse_oro_opts_custom: got %"U16_F"\n", requested_options[i]));
+      LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM(netif, requested_options[i], dhcp6->state, p, opt_offset, opt_len);
     }
   }
-  return ERR_OK;
 }
+#endif /* LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM */
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+static u8_t
+dhcp6_parse_ia_na(struct pbuf *p, u16_t offset, struct dhcp6 *dhcp6)
+{
+  const u16_t ia_len = dhcp6_find_option(p, DHCP6_OPTION_IA_NA, &offset);
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" dhcp6_parse_ia_na:"));
+
+  if (ia_len >= (sizeof(struct dhcp6_option_ia) + sizeof(struct dhcp6_option_ia_address) + 4)) {
+    struct dhcp6_option_ia buf;
+    const struct dhcp6_option_ia *opt_ia =
+            (const struct dhcp6_option_ia *)pbuf_get_contiguous(p, &buf, sizeof(buf), sizeof(buf), offset);
+    if (opt_ia != NULL) {
+      u16_t ia_opt_offset = offset + sizeof(struct dhcp6_option_ia); /* Address option is inside ia option. */
+      const u16_t ia_addr_opt_len = dhcp6_find_option(p, DHCP6_OPTION_IAADDR, &ia_opt_offset);
+
+      if (ia_addr_opt_len >= sizeof(struct dhcp6_option_ia_address)) {
+        struct dhcp6_option_ia_address a_buf;
+        const struct dhcp6_option_ia_address *opt_ia_addr =
+                (struct dhcp6_option_ia_address *)pbuf_get_contiguous(
+                        p, &a_buf, sizeof(a_buf), sizeof(a_buf), ia_opt_offset);
+
+        if (opt_ia_addr != NULL) {
+          dhcp6->addr_t1 = lwip_ntohl(opt_ia->t1);
+          dhcp6->addr_t2 = lwip_ntohl(opt_ia->t2);
+
+          memcpy(&dhcp6->addr.addr, &opt_ia_addr->address, sizeof(opt_ia_addr->address));
+          dhcp6->addr_pref = lwip_ntohl(opt_ia_addr->preferred);
+          dhcp6->addr_valid = lwip_ntohl(opt_ia_addr->valid);
+
+          LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" %s t1=%"U32_F" t2=%"U32_F" prf=%"U32_F" val=%"U32_F"\n",
+                      ip6addr_ntoa(&dhcp6->addr), dhcp6->addr_t1, dhcp6->addr_t2, dhcp6->addr_pref, dhcp6->addr_valid));
+          return 1;
+        }
+      }
+    }
+  }
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" got nothing\n"));
+  return 0;
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+#if LWIP_IPV6_DHCP6_PD
+
+/* stores server id in to dhcp6 struct */
+static u8_t
+dhcp6_parse_ia_pd(struct pbuf *p, u16_t offset, struct dhcp6 *dhcp6)
+{
+  const s16_t ia_len = dhcp6_find_option(p, DHCP6_OPTION_IA_PD, &offset);
+
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" dhcp6_parse_ia_pd:"));
+
+  if (ia_len >= (s16_t)(sizeof(struct dhcp6_option_ia) + sizeof(struct dhcp6_option_ia_pd) + 4)) {
+    struct dhcp6_option_ia buf;
+    const struct dhcp6_option_ia *opt_ia =
+            (struct dhcp6_option_ia *)pbuf_get_contiguous(p, &buf, sizeof(buf), sizeof(buf), offset);
+
+    u16_t ia_opt_offset = offset + sizeof(struct dhcp6_option_ia); /* Address option is inside ia option. */
+    const s16_t ia_addr_opt_len = dhcp6_find_option(p, DHCP6_OPTION_IAPREFIX, &ia_opt_offset);
+
+    if (ia_addr_opt_len >= (s16_t)sizeof(struct dhcp6_option_ia_pd)) {
+      struct dhcp6_option_ia_pd p_buf;
+      const struct dhcp6_option_ia_pd *opt_ia_pref =
+              (const struct dhcp6_option_ia_pd *) pbuf_get_contiguous(
+                      p, &p_buf, sizeof(p_buf), sizeof(p_buf), ia_opt_offset);
+
+      dhcp6->ia_pd_t1 = lwip_ntohl(opt_ia->t1);
+      dhcp6->ia_pd_t2 = lwip_ntohl(opt_ia->t2);
+
+      memcpy(&dhcp6->prefix.prefix.addr, &opt_ia_pref->prefix, sizeof(opt_ia_pref->prefix));
+      dhcp6->prefix.prefix_len = opt_ia_pref->prefix_length;
+      dhcp6->prefix.prefix_pref = lwip_ntohl(opt_ia_pref->preferred);
+      dhcp6->prefix.prefix_valid = lwip_ntohl(opt_ia_pref->valid);
+
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" %s/%"U16_F" t1=%"U32_F" t2=%"U32_F" prf=%"U32_F" val=%"U32_F"\n",
+              ip6addr_ntoa(&dhcp6->prefix.prefix), (u16_t)dhcp6->prefix.prefix_len,
+              dhcp6->ia_pd_t1, dhcp6->ia_pd_t1, dhcp6->prefix.prefix_pref, dhcp6->prefix.prefix_valid));
+
+      return 1;
+    }
+  }
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, (" got nothing\n"));
+  return 0;
+}
+#endif /* LWIP_IPV6_DHCP6_PD */
 
 static void
 dhcp6_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr, u16_t port)
